// $Id$

Drupal.behaviors.ufajaxAutoBehavior = function (context) {
  $('#ufajax-wrapper-title input:not(.ufajax-behavior-processed)', context)
    .addClass('ufajax-behavior-processed')
    .each(function () {
      var titleField = $(this);
      
      var ufajaxPos = titleField.position();
      var ufajaxWidth = titleField.width();
      
      Drupal.ufajaxCheckTitle = '';
      $('#ufajax-informer-title')
        .css({left: (ufajaxPos.left+ufajaxWidth+10)+'px', top: (ufajaxPos.top)+'px'})
        .show(); 
      
      titleField
        .keyup(function () {
          if(titleField.val() != Drupal.ufajaxCheckTitle) {
            clearTimeout(Drupal.ufajaxCheckTimer);
            Drupal.ufajaxCheckTimer = setTimeout(function () {ufajaxCheck(titleField)}, Drupal.settings.ufajax.delay*1000);
          
            if(!$("#ufajax-informer-title").hasClass('ufajax-check-informer-progress')) {
              $("#ufajax-informer-title")
                .removeClass('ufajax-check-informer-accepted')
                .removeClass('ufajax-check-informer-rejected');
            }
              
            $("#ufajax-message-title")
              .hide();
          }
        })
        .blur(function () {
          if(titleField.val() != Drupal.ufajaxCheckTitle) {
            ufajaxCheck(titleField);
          }
        });
    });

  $('#ufajax-wrapper-field input:not(.ufajax-behavior-processed)', context)
    .addClass('ufajax-behavior-processed')
    .each(function () {
      var titleField = $(this);
      
      var ufajaxPos = titleField.position();
      var ufajaxWidth = titleField.width();
      
      Drupal.ufajaxfieldsCheckTitle = '';
      $('#ufajax-informer-field')
        .css({left: (ufajaxPos.left+ufajaxWidth+10)+'px', top: (ufajaxPos.top)+'px'})
        .show(); 
      
      titleField
        .keyup(function () {
          if(titleField.val() != Drupal.ufajaxfieldsCheckTitle) {
            clearTimeout(Drupal.ufajaxCheckTimer);
            Drupal.ufajaxfieldsCheckTimer = setTimeout(function () {ufajaxfieldsCheck(titleField)}, Drupal.settings.ufajaxfields.delay*1000);
          
            if(!$("#ufajax-informer-field").hasClass('ufajax-check-informer-progress')) {
              $("#ufajax-informer-field")
                .removeClass('ufajax-check-informer-accepted')
                .removeClass('ufajax-check-informer-rejected');
            }
              
            $("#ufajax-message-field")
              .hide();
          }
        })
        .blur(function () {
          if(titleField.val() != Drupal.ufajaxfieldsCheckTitle) {
            ufajaxfieldsCheck(titleField);
          }
        });  
    });
}

function ufajaxCheck(titleField) {
  clearTimeout(Drupal.ufajaxCheckTimer);
  Drupal.ufajaxCheckTitle = titleField.val();
  
  $.ajax({
    url: Drupal.settings.ufajax.ajaxUrl,
    data: {
      title: Drupal.ufajaxCheckTitle,
      ntype: Drupal.settings.ufajax.ntype,
      nid: Drupal.settings.ufajax.nid
    },
    dataType: 'json',
    beforeSend: function() {
      $("#ufajax-informer-title")
        .removeClass('ufajax-informer-accepted')
        .removeClass('ufajax-informer-rejected')
        .addClass('ufajax-informer-progress');
    },
    success: function(ret){
      if(ret['allowed']){
        $("#ufajax-informer-title")
          .removeClass('ufajax-informer-progress')
          .addClass('ufajax-informer-accepted');
        
        titleField
          .removeClass('error');
      }
      else {
        $("#ufajax-informer-title")
          .removeClass('ufajax-informer-progress')
          .addClass('ufajax-informer-rejected');
        
        $("#ufajax-message-title")
          .addClass('ufajax-message-rejected')
          .html(ret['msg'])
          .show();
      }
    }
   });
}

function ufajaxfieldsCheck(titleField) {
  clearTimeout(Drupal.ufajaxCheckTimer);
  Drupal.ufajaxfieldsCheckTitle = titleField.val();
  
  $.ajax({
    url: Drupal.settings.ufajaxfields.ajaxUrl,
    data: {
      title: Drupal.ufajaxfieldsCheckTitle,
      node: Drupal.settings.ufajaxfields.node
    },
    dataType: 'json',
    beforeSend: function() {
      $("#ufajax-informer-field")
        .removeClass('ufajax-informer-accepted')
        .removeClass('ufajax-informer-rejected')
        .addClass('ufajax-informer-progress');
    },
    success: function(ret){
      if(ret['allowed']){
        $("#ufajax-informer-field")
          .removeClass('ufajax-informer-progress')
          .addClass('ufajax-informer-accepted');
        
        titleField
          .removeClass('error');
      }
      else {
        $("#ufajax-informer-field")
          .removeClass('ufajax-informer-progress')
          .addClass('ufajax-informer-rejected');
        
        $("#ufajax-message-field")
          .addClass('ufajax-message-rejected')
          .html(ret['msg'])
          .show();
      }
    }
   });
}
